%% Redo 2
% Want to create a surface and look at it averaged over a
% a particular resolution
Nx = 1500;
Ny = 1500;
Nxavg = 25;
Nyavg = 25;

%% Initial Parameter Values

tic

Lx = 10; % Length of x dimension
Ly = 10; % Length of y dimension

x = linspace(1,Lx,Nx).';  % Creating x vector
y = linspace(1,Ly,Ny);  % Creating y vector

%% Setting up values of surface on grid


mysurf = 5*cos((x+y)*2*pi)+...
    2*sin(x*2*pi)+2*cos(x*2*pi);


%% Averaging values over the grid

% Preallocation
mysurf_avg = zeros(floor(length(x)/Nxavg),floor(length(y)/Nyavg));
xavg = zeros(1,floor(length(x)/Nxavg));
yavg = zeros(1,floor(length(y)/Nyavg));

for i = Nxavg:length(x)
    for j = Nyavg:length(y)
         if (mod(j,Nyavg)==0 && mod(i,Nxavg)==0)

           idown = i-Nxavg+1;
           jdown = j-Nyavg+1;
           iup = i;
           jup = j;
           
           iavg = floor(i/Nxavg);
           javg = floor(j/Nyavg);
           
           mysurf_avg(iavg,javg) =...
               sum(sum(mysurf(idown:iup,jdown:jup)))/(Nxavg*Nyavg);
           
           xavg(iavg) = (x(iup)+x(idown))/2;
           yavg(javg) = (y(jup)+y(jdown))/2;
           
         end
    end
end

toc

%% Plotting the results to compare
myPlot(x,y,mysurf,xavg,yavg,mysurf_avg)



