%% Redo 2
% Want to create a surface and look at it averaged over a
% a particular resolution
Nx = 1500;
Ny = 1500;
Nxavg = 25;
Nyavg = 25;

%% Initial Parameter Values

tic

Lx = 10; % Length of x dimension
Ly = 10; % Length of y dimension

x = linspace(1,Lx,Nx).';  % Creating x vector
y = linspace(1,Ly,Ny);  % Creating y vector

%% Setting up values of surface on grid


mysurf = 5*cos((x+y)*2*pi)+...
    2*sin(x*2*pi)+2*cos(x*2*pi);


%% Averaging values over the grid

% Average x and y positions
xavg = x(Nxavg:Nxavg:Nx) - 0.5*(x(Nxavg)-x(1));
yavg = y(Nyavg:Nyavg:Ny) - 0.5*(y(Nyavg)-y(1));

% Cropping and reshaping and summing
newX = (1:floor(Nx/Nxavg)*Nxavg);  % removing excess points 
newY = (1:floor(Ny/Nyavg)*Nyavg);  % not used in averaging

mysurf_avg = sum(reshape(mysurf(newX,newY),Nxavg,[]));
mysurf_avg = reshape((1/Nxavg)* mysurf_avg,floor(Nx/Nxavg),[]);

mysurf_avg = sum(reshape(mysurf_avg',Nyavg,[]));
mysurf_avg = reshape((1/Nyavg)* mysurf_avg,floor(Ny/Nxavg),[])';

toc

%% Plotting the results to compare
myPlot(x,y,mysurf,xavg,yavg,mysurf_avg)



