function prob = runBirthdayUnique1(numTrials, groupSize)
% RUNBIRTHDAYUNIQUE1 Runs a Monte Carlo simulation using the Birthday Paradox
% code
%    PROB = RUNBIRTHDAYUNIQUE1(NUMTRIALS, GROUPSIZE) Calls the birthday code
%    NUMTRIALS times to see if any birthdays match in a group of size
%    GROUPSIZE.  The return value is the probability that a match will be
%    found.
%
%    Example:
%    p = runBirthdayUnique1(1e5, 30)

matches = false(1, numTrials);
for trial = 1:numTrials
    % Run a simulation for a group
    matches(trial) = birthday(groupSize);
end

% Probability is the sum of matches divided by number of trials
prob = sum(matches)/numTrials;


function match = birthday(groupSize)
% BIRTHDAY Simulates a single trial of the Birthday Paradox

%% TODO 
% without a FOR loop create a list with a random birthday for each member in the group
bdays = randi(365, groupSize, 1);

% Use |unique| for testing
if length(unique(bdays)) == numel(bdays)
    match = false;
else
    match = true;
end