function pi_N = calcPI(nNeedles,nLength,a,b)
%CALCPI 
rng('default')
x0  = a * rand(nNeedles,1);
y0  = b * rand(nNeedles,1);
phi = 2 * pi * rand(nNeedles,1);

% Calculate tail positions of each needle
x = x0 + nLength * cos(phi);
y = y0 + nLength * sin(phi);

% Does needle cross over boundary of the box (grid)
ncross = nnz(x <= 0.0 | x >= a | y <= 0.0 | y >= b);

%Calculating estimate of pi from probablity of needle crossing

pi_N = (2 * nLength * (a + b) - nLength^2)...
    /(a * b)* nNeedles/ncross;


