function pi_N = spmdCalcPI(nNeedles,a,b,nLength)

rng('default')
x0 = a * rand([nNeedles,1],'codistributed');
y0 = b * rand([nNeedles,1],'codistributed');
phi = 2 * pi * rand([nNeedles,1],'codistributed');

% Calculate tail positions of each needle
x = x0 + nLength * cos(phi);
y = y0 + nLength * sin(phi);

% Does needle cross over boundary of the box (grid)
ncross = nnz(x <= 0.0 | x >= a | y <= 0.0 | y >= b);
% Calculating estimate of pi from probablity of needle crossing
pi_N = (2 * nLength * (a + b) - nLength^2)...
    /(a * b)* nNeedles/ncross;
end
